/*
 * Handle Accumulating VST events
 *
 */

autowatch = 1;
inlets = 2;
outlets = 4;

var my_events = [];
var dict = null;

if( jsarguments.length>1 ) {
	dict = new Dict(jsarguments[1]);
} else {
	dict = new Dict;
}

function _zpad(num, size) {
    var s = num+"";
    while (s.length < size) s = "0" + s;
    return s;
}

function _readDict() {
	
	// Get the keys
	keys = dict.getkeys();
	
	// Not sure why but if we have one key we only
	// get a string back.
	if( typeof(keys) == 'string' ) {
		keys=[keys];
	}
	
	// Sort the keys
	keys=keys.sort();
	
	// Clear the list
	my_events = [];
	
	// Build the list based on the keys
	for(kn=0; kn<keys.length; kn++) {
		my_events.push( dict.get(keys[kn]) );
	}
}

function _writeDict() {
	// Clear the dictionary
	dict.clear();
	
	// Add the events from the list to the dict
	for( i=0; i<my_events.length; i++ ) {
		dict.set( _zpad(i,2), my_events[i]);
	}
}

function edit() {
	post("foo");
	post();
	_writeDict();
	outlet(3, ["edit"]);	
}

function loadbang() {
	_readDict();
}

function append(/*list*/) {
	if( inlet == 0 ) {
		argarr = Array.prototype.slice.call(arguments);
		my_events.push(argarr);
		_writeDict();
	}
}

function merge(/*list*/) {
	argarr = Array.prototype.slice.call(arguments);
	
	// Find any matching events and update them
	for( i=0; i<my_events.length; i++ ) {
		if( my_events[i][1] == argarr[1] ) {
			my_events[i] = argarr;
			break;
		}
	}
	
	// If we didn't get a match, append it
	if( i == my_events.length ) {
		my_events.push( argarr );
	}

	// Push the updated data back to the text box
	_writeDict();
}


function send() {
	if( inlet == 0 ) {
		for( i=0; i<my_events.length; i++ ) {
			outlet( 0, my_events[i] );
		}
	}
}

function text(t) {
	/*argarr = Array.prototype.slice.call(arguments);

	for( i=0; i<argarr.length; i++ ) {
		outlet(1, argarr[i].constructor.toString());
	}*/
	
	evs = t.match(/"(?:\\"|[^"])+"|,|[^, \t\r\n]+/g) || [];
	my_events = [];
	accum = [];
	for( i=0; i<evs.length; i++ ) {
		if( evs[i] == "," ) {
			my_events.push( accum );
			accum = [];
		} else if( evs[i].charAt(0) == "\"" ) {
			accum.push( evs[i].substr(1, evs[i].length-2 ) );
		} else {
			accum.push( evs[i] );
		}
	}
}
